generic/225: Require fiemap support
[ddiss/fstests.git] / common / config
1 ##/bin/bash
2 #
3 # Copyright (c) 2000-2003,2006 Silicon Graphics, Inc.  All Rights Reserved.
4 #
5 # This program is free software; you can redistribute it and/or
6 # modify it under the terms of the GNU General Public License as
7 # published by the Free Software Foundation.
8 #
9 # This program is distributed in the hope that it would be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
12 # GNU General Public License for more details.
13 #
14 # You should have received a copy of the GNU General Public License
15 # along with this program; if not, write the Free Software Foundation,
16 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
17 #
18 #
19 # setup and check for config parameters, and in particular
20 #
21 # EMAIL -           email of the script runner.
22 # TEST_DIR -        scratch test directory that is in an already
23 #                   mounted XFS file system, needs to be be world
24 #                   writeable
25 # TEST_DEV -        device for file system containing TEST_DIR
26 #
27 # and optionally:
28 # SCRATCH_DEV -     device you can make a scratch file system on
29 # SCRATCH_MNT -     mount point for scratch file system
30 # SCRATCH_LOGDEV -  scratch log device for external log testing
31 # SCRATCH_RTDEV -   scratch rt dev
32 # TEST_LOGDEV -     test log device for external log testing
33 # TEST_RTDEV -      test rt dev
34 # TAPE_DEV -        the tape device for the xfsdump tests
35 # RMT_TAPE_DEV -    the remote tape device for the xfsdump tests
36 # RMT_IRIXTAPE_DEV- the IRIX remote tape device for the xfsdump tests
37 # RMT_TAPE_USER -   remote user for tape device
38 #
39 # - These can be added to $HOST_CONFIG_DIR (witch default to ./config)
40 #   below or a separate local configuration file can be used (using
41 #   the HOST_OPTIONS variable).
42 # - This script is shared by the stress test system and the auto-qa
43 #   system
44 # - TEST_DEV & TEST_DIR must be assigned.
45 # - this script shouldn't make any assertions about filesystem
46 #   validity or mountedness.
47 #
48
49 # all tests should use a common language setting to prevent golden
50 # output mismatches.
51 export LANG=C
52 export LC_ALL=C
53
54 # Warning: don't put freeware before /usr/bsd on IRIX coz you'll
55 #  get the wrong hostname and set your system name to -s  :)
56 [ -d /usr/bsd ] && PATH=$PATH:/usr/bsd
57 [ -d /usr/freeware/bin ] && PATH=$PATH:/usr/freeware/bin
58 PATH=".:$PATH"
59
60 export HOST=`hostname -s`
61 export HOSTOS=`uname -s`
62 [ "$HOSTOS" = "IRIX64" ] && export HOSTOS="IRIX"
63
64 export MODULAR=0               # using XFS as a module or not
65 export BOOT="/boot"            # install target for kernels
66 export EXTRA=${EXTRA:=xfs-qa}
67
68 # general parameters (mainly for auto-qa)
69 export SOAK_PROC=3             # -p option to fsstress
70 export SOAK_STRESS=10000       # -n option to fsstress
71 export SOAK_PASSES=-1          # count of repetitions of fsstress (while soaking)
72 export EMAIL=root@localhost    # where auto-qa will send its status messages
73 export HOST_OPTIONS=${HOST_OPTIONS:=local.config}
74 export CHECK_OPTIONS=${CHECK_OPTIONS:="-g auto"}
75 export BENCH_PASSES=${BENCH_PASSES:=5}
76 export XFS_MKFS_OPTIONS=${XFS_MKFS_OPTIONS:=-bsize=4096}
77 export TIME_FACTOR=${TIME_FACTOR:=1}
78 export LOAD_FACTOR=${LOAD_FACTOR:=1}
79 export DEBUGFS_MNT=${DEBUGFS_MNT:="/sys/kernel/debug"}
80
81 export PWD=`pwd`
82 #export DEBUG=${DEBUG:=...} # arbitrary CFLAGS really.
83 export MALLOCLIB=${MALLOCLIB:=/usr/lib/libefence.a}
84 export LOCAL_CONFIGURE_OPTIONS=${LOCAL_CONFIGURE_OPTIONS:=--enable-readline=yes}
85
86 export RECREATE_TEST_DEV=false
87
88 # $1 = prog to look for, $2* = default pathnames if not found in $PATH
89 set_prog_path()
90 {
91     p=`which $1 2> /dev/null`
92     if [ -n "$p" -a -x "$p" ]; then
93         echo $p
94         return 0
95     fi
96     p=$1
97
98     shift
99     for f; do
100         if [ -x $f ]; then
101             echo $f
102             return 0
103         fi
104     done
105
106     echo ""
107     return 1
108 }
109
110 # Handle mkfs.btrfs which does (or does not) require -f to overwrite
111 set_btrfs_mkfs_prog_path_with_opts()
112 {
113         p=`set_prog_path mkfs.btrfs`
114         if [ "$p" != "" ] && grep -q 'force overwrite' $p; then
115                 echo "$p -f"
116         else
117                 echo $p
118         fi
119 }
120
121 _fatal()
122 {
123     echo "$*"
124     status=1
125     exit 1
126 }
127
128 export MKFS_PROG="`set_prog_path mkfs`"
129 [ "$MKFS_PROG" = "" ] && _fatal "mkfs not found"
130
131 export MOUNT_PROG="`set_prog_path mount`"
132 [ "$MOUNT_PROG" = "" ] && _fatal "mount not found"
133
134 export UMOUNT_PROG="`set_prog_path umount`"
135 [ "$UMOUNT_PROG" = "" ] && _fatal "umount not found"
136
137 export FSSTRESS_PROG="./ltp/fsstress"
138 [ "$FSSTRESS_PROG" = "" ] && _fatal "fsstress not found"
139
140 export PERL_PROG="`set_prog_path perl`"
141 [ "$PERL_PROG" = "" ] && _fatal "perl not found"
142
143 export AWK_PROG="`set_prog_path awk`"
144 [ "$AWK_PROG" = "" ] && _fatal "awk not found"
145
146 export SED_PROG="`set_prog_path sed`"
147 [ "$SED_PROG" = "" ] && _fatal "sed not found"
148
149 export BC_PROG="`set_prog_path bc`"
150 [ "$BC_PROG" = "" ] && _fatal "bc not found"
151
152 export PS_ALL_FLAGS="-ef"
153
154 export DF_PROG="`set_prog_path df`"
155 [ "$DF_PROG" = "" ] && _fatal "df not found"
156 [ "$HOSTOS" = "Linux" ] && export DF_PROG="$DF_PROG -T -P"
157
158 export XFS_LOGPRINT_PROG="`set_prog_path xfs_logprint`"
159 export XFS_REPAIR_PROG="`set_prog_path xfs_repair`"
160 export XFS_DB_PROG="`set_prog_path xfs_db`"
161 export XFS_GROWFS_PROG=`set_prog_path xfs_growfs`
162 export XFS_IO_PROG="`set_prog_path xfs_io`"
163 export XFS_PARALLEL_REPAIR_PROG="`set_prog_path xfs_prepair`"
164 export XFS_PARALLEL_REPAIR64_PROG="`set_prog_path xfs_prepair64`"
165 export __XFSDUMP_PROG="`set_prog_path xfsdump`"
166 export XFSDUMP_PROG="$__XFSDUMP_PROG -e"
167 export XFSRESTORE_PROG="`set_prog_path xfsrestore`"
168 export XFSINVUTIL_PROG="`set_prog_path xfsinvutil`"
169 export GETFATTR_PROG="`set_prog_path getfattr`"
170 export SETFATTR_PROG="`set_prog_path setfattr`"
171 export CHACL_PROG="`set_prog_path chacl`"
172 export ATTR_PROG="`set_prog_path attr`"
173 export QUOTA_PROG="`set_prog_path quota`"
174 export XFS_QUOTA_PROG="`set_prog_path xfs_quota`"
175 export KILLALL_PROG="`set_prog_path killall`"
176 export INDENT_PROG="`set_prog_path indent`"
177 export XFS_COPY_PROG="`set_prog_path xfs_copy`"
178 export FSTRIM_PROG="`set_prog_path fstrim`"
179 export DUMPE2FS_PROG="`set_prog_path dumpe2fs`"
180 export FIO_PROG="`set_prog_path fio`"
181 export FILEFRAG_PROG="`set_prog_path filefrag`"
182 export E4DEFRAG_PROG="`set_prog_path e4defrag`"
183 export LOGGER_PROG="`set_prog_path logger`"
184 export DBENCH_PROG="`set_prog_path dbench`"
185 export DMSETUP_PROG="`set_prog_path dmsetup`"
186 export WIPEFS_PROG="`set_prog_path wipefs`"
187
188 # Generate a comparable xfsprogs version number in the form of
189 # major * 10000 + minor * 100 + release
190 #
191 # $ xfs_db -V
192 # xfs_db version 2.9.7
193 #
194 # so, 2.9.7 = 20907
195 _version=`$XFS_DB_PROG -V | $AWK_PROG '
196         /version/ {
197                 if (split($3,ver,".") == 3)
198                         print (ver[1] * 10000) + (ver[2] * 100) + ver[3];
199         }'`
200 [ -z "$_version" ] && _fatal "xfsprogs version cannot be found"
201 export XFSPROGS_VERSION="$_version"
202
203 case "$HOSTOS" in
204     IRIX*)
205         export MKFS_XFS_PROG="`set_prog_path mkfs_xfs`"
206         export MKFS_UDF_PROG="`set_prog_path mkfs_udf`"
207         export XFS_FSR_PROG="`set_prog_path /usr/etc/fsr_xfs`"
208         export MKFS_NFS_PROG="false"
209         ;;
210     Linux)
211         export MKFS_XFS_PROG="`set_prog_path mkfs.xfs`"
212         export MKFS_UDF_PROG="`set_prog_path mkudffs`"
213         export MKFS_BTRFS_PROG="`set_btrfs_mkfs_prog_path_with_opts`"
214         export BTRFS_UTIL_PROG="`set_prog_path btrfs`"
215         export BTRFS_SHOW_SUPER_PROG="`set_prog_path btrfs-show-super`"
216         export XFS_FSR_PROG="`set_prog_path xfs_fsr`"
217         export MKFS_NFS_PROG="false"
218         ;;
219 esac
220
221 # SELinux adds extra xattrs which can mess up our expected output.
222 # So, mount with a context, and they won't be created
223 # # nfs_t is a "liberal" context so we can use it.
224 if [ -x /usr/sbin/selinuxenabled ] && /usr/sbin/selinuxenabled; then
225         SELINUX_MOUNT_OPTIONS="-o context=system_u:object_r:nfs_t:s0"
226         export SELINUX_MOUNT_OPTIONS
227 fi
228
229 _mount_opts()
230 {
231         case $FSTYP in
232         xfs)
233                 export MOUNT_OPTIONS=$XFS_MOUNT_OPTIONS
234                 ;;
235         udf)
236                 export MOUNT_OPTIONS=$UDF_MOUNT_OPTIONS
237                 ;;
238         nfs)
239                 export MOUNT_OPTIONS=$NFS_MOUNT_OPTIONS
240                 ;;
241         ext2|ext3|ext4|ext4dev)
242                 # acls & xattrs aren't turned on by default on ext$FOO
243                 export MOUNT_OPTIONS="-o acl,user_xattr $EXT_MOUNT_OPTIONS"
244                 ;;
245         reiserfs)
246                 # acls & xattrs aren't turned on by default on reiserfs
247                 export MOUNT_OPTIONS="-o acl,user_xattr $REISERFS_MOUNT_OPTIONS"
248                 ;;
249         gfs2)
250                 # acls aren't turned on by default on gfs2
251                 export MOUNT_OPTIONS="-o acl $GFS2_MOUNT_OPTIONS"
252                 ;;
253         tmpfs)
254                 # We need to specify the size at mount, use 512 MB by default
255                 export MOUNT_OPTIONS="-o size=512M $TMPFS_MOUNT_OPTIONS"
256                 ;;
257         *)
258                 ;;
259         esac
260 }
261
262 _mkfs_opts()
263 {
264         case $FSTYP in
265         xfs)
266                 export MKFS_OPTIONS=$XFS_MKFS_OPTIONS
267                 ;;
268         udf)
269                 [ ! -z "$udf_fsize" ] && \
270                         UDF_MKFS_OPTIONS="$UDF_MKFS_OPTIONS -s $udf_fsize"
271                 export MKFS_OPTIONS=$UDF_MKFS_OPTIONS
272                 ;;
273         nfs)
274                 export MKFS_OPTIONS=$NFS_MKFS_OPTIONS
275                 ;;
276         reiserfs)
277                 export MKFS_OPTIONS="$REISERFS_MKFS_OPTIONS -q"
278                 ;;
279         gfs2)
280                 export MKFS_OPTIONS="$GFS2_MKFS_OPTIONS -O -p lock_nolock"
281                 ;;
282         jfs)
283                 export MKFS_OPTIONS="$JFS_MKFS_OPTIONS -q"
284                 ;;
285         *)
286                 ;;
287         esac
288 }
289
290 _fsck_opts()
291 {
292         case $FSTYP in
293         ext2|ext3|ext4|ext4dev)
294                 export FSCK_OPTIONS="-nf"
295                 ;;
296         reiserfs)
297                 export FSCK_OPTIONS="--yes"
298                 ;;
299         *)
300                 export FSCK_OPTIONS="-n"
301                 ;;
302         esac
303 }
304
305 known_hosts()
306 {
307         [ "$HOST_CONFIG_DIR" ] || HOST_CONFIG_DIR=`pwd`/configs
308
309         [ -f /etc/xfsqa.config ]             && export HOST_OPTIONS=/etc/xfsqa.config
310         [ -f $HOST_CONFIG_DIR/$HOST ]        && export HOST_OPTIONS=$HOST_CONFIG_DIR/$HOST
311         [ -f $HOST_CONFIG_DIR/$HOST.config ] && export HOST_OPTIONS=$HOST_CONFIG_DIR/$HOST.config
312 }
313
314 # Returns a list of sections in config file
315 # Each section starts with the section name in the format
316 # [section_name1]. Only alphanumeric characters and '_' is allowed
317 # in the section name otherwise the section will not be resognised.
318 # Section name must be contained between square brackets.
319 get_config_sections() {
320         sed -n -e "s/^\[\([[:alnum:]_]*\)\]/\1/p" < $1
321 }
322
323 if [ ! -f "$HOST_OPTIONS" ]; then
324         known_hosts
325 fi
326
327 export HOST_OPTIONS_SECTIONS="-no-sections-"
328 export OPTIONS_HAVE_SECTIONS=false
329 if [ -f "$HOST_OPTIONS" ]; then
330         export HOST_OPTIONS_SECTIONS=`get_config_sections $HOST_OPTIONS`
331         if [ -z "$HOST_OPTIONS_SECTIONS" ]; then
332                 . $HOST_OPTIONS
333                 export HOST_OPTIONS_SECTIONS="-no-sections-"
334         else
335                 export OPTIONS_HAVE_SECTIONS=true
336         fi
337 fi
338
339 # Parse config section options. This function will parse all the configuration
340 # within a single section which name is passed as an argument. For section
341 # name format see comments in get_config_sections().
342 # Empty lines and everything after '#' will be ignored.
343 # Configuration options should be defined in the format
344 #
345 # CONFIG_OPTION=value
346 #
347 # This 'CONFIG_OPTION' variable and will be exported as an environment variable.
348 parse_config_section() {
349         SECTION=$1
350         if ! $OPTIONS_HAVE_SECTIONS; then
351                 return 0
352         fi
353         eval `sed -e 's/[[:space:]]*\=[[:space:]]*/=/g' \
354                 -e 's/#.*$//' \
355                 -e 's/[[:space:]]*$//' \
356                 -e 's/^[[:space:]]*//' \
357                 -e "s/^\([^=]*\)=\"\?'\?\([^\"']*\)\"\?'\?$/export \1=\"\2\"/" \
358                 < $HOST_OPTIONS \
359                 | sed -n -e "/^\[$SECTION\]/,/^\s*\[/{/^[^#].*\=.*/p;}"`
360 }
361
362 get_next_config() {
363         if [ ! -z "$CONFIG_INCLUDED" ] && ! $OPTIONS_HAVE_SECTIONS; then
364                 return 0
365         fi
366
367         local OLD_FSTYP=$FSTYP
368         local OLD_MOUNT_OPTIONS=$MOUNT_OPTIONS
369         local OLD_MKFS_OPTIONS=$MKFS_OPTIONS
370         local OLD_FSCK_OPTIONS=$FSCK_OPTIONS
371
372         unset MOUNT_OPTIONS
373         unset MKFS_OPTIONS
374         unset FSCK_OPTIONS
375         # We might have deduced SCRATCH_DEV from the SCRATCH_DEV_POOL in the previous
376         # run, so we have to unset it now.
377         if [ "$SCRATCH_DEV_NOT_SET" == "true" ]; then
378                 unset SCRATCH_DEV
379         fi
380
381         parse_config_section $1
382
383         if [ ! -z "$OLD_FSTYP" ] && [ $OLD_FSTYP != $FSTYP ]; then
384                 [ -z "$MOUNT_OPTIONS" ] && _mount_opts
385                 [ -z "$MKFS_OPTIONS" ] && _mkfs_opts
386                 [ -z "$FSCK_OPTIONS" ] && _fsck_opts
387         else
388                 [ -z "$MOUNT_OPTIONS" ] && export MOUNT_OPTIONS=$OLD_MOUNT_OPTIONS
389                 [ -z "$MKFS_OPTIONS" ] && export MKFS_OPTIONS=$OLD_MKFS_OPTIONS
390                 [ -z "$FSCK_OPTIONS" ] && export FSCK_OPTIONS=$OLD_FSCK_OPTIONS
391         fi
392
393         # set default RESULT_BASE
394         if [ -z "$RESULT_BASE" ]; then
395                 export RESULT_BASE="$here/results/"
396         fi
397
398         #  Mandatory Config values.
399         MC=""
400         [ -z "$EMAIL" ]          && MC="$MC EMAIL"
401         [ -z "$TEST_DIR" ]       && MC="$MC TEST_DIR"
402         [ -z "$TEST_DEV" ]       && MC="$MC TEST_DEV"
403
404         if [ -n "$MC" ]; then
405                 echo "Warning: need to define parameters for host $HOST"
406                 echo "       or set variables:"
407                 echo "       $MC"
408                 exit 1
409         fi
410
411         echo $TEST_DEV | grep -q ":" > /dev/null 2>&1
412         if [ ! -b "$TEST_DEV" -a "$?" != "0" ]; then
413                 echo "common/config: Error: \$TEST_DEV ($TEST_DEV) is not a block device or a NFS filesystem"
414                 exit 1
415         fi
416
417         if [ ! -d "$TEST_DIR" ]; then
418                 echo "common/config: Error: \$TEST_DIR ($TEST_DIR) is not a directory"
419                 exit 1
420         fi
421
422         # a btrfs tester will set only SCRATCH_DEV_POOL, we will put first of its dev
423         # to SCRATCH_DEV and rest to SCRATCH_DEV_POOL to maintain the backward compatibility
424         if [ ! -z "$SCRATCH_DEV_POOL" ]; then
425                 if [ ! -z "$SCRATCH_DEV" ]; then
426                         echo "common/config: Error: \$SCRATCH_DEV ($SCRATCH_DEV) should be unset when \$SCRATCH_DEV_POOL ($SCRATCH_DEV_POOL) is set"
427                         exit 1
428                 fi
429                 SCRATCH_DEV=`echo $SCRATCH_DEV_POOL | awk '{print $1}'`
430                 export SCRATCH_DEV
431                 export SCRATCH_DEV_NOT_SET=true
432         fi
433
434         echo $SCRATCH_DEV | grep -q ":" > /dev/null 2>&1
435         if [ ! -z "$SCRATCH_DEV" -a ! -b "$SCRATCH_DEV" -a "$?" != "0" ]; then
436                 echo "common/config: Error: \$SCRATCH_DEV ($SCRATCH_DEV) is not a block device or a NFS filesystem"
437                 exit 1
438         fi
439
440         if [ ! -z "$SCRATCH_MNT" -a ! -d "$SCRATCH_MNT" ]; then
441                 echo "common/config: Error: \$SCRATCH_MNT ($SCRATCH_MNT) is not a directory"
442                 exit 1
443         fi
444 }
445
446 if [ -z "$CONFIG_INCLUDED" ]; then
447         get_next_config `echo $HOST_OPTIONS_SECTIONS | cut -f1 -d" "`
448         export CONFIG_INCLUDED=true
449
450         # Autodetect fs type based on what's on $TEST_DEV unless it's been set
451         # externally
452         if [ -z "$FSTYP" ] && \
453            [ "$HOSTOS" == "Linux" -o "$OSTYPE" == "linux-gnu" ] && \
454            [ ! -z "$TEST_DEV" ]; then
455                 FSTYP=`blkid -c /dev/null -s TYPE -o value $TEST_DEV`
456         fi
457         FSTYP=${FSTYP:=xfs}
458         export FSTYP
459         [ -z "$MOUNT_OPTIONS" ] && _mount_opts
460         [ -z "$MKFS_OPTIONS" ] && _mkfs_opts
461         [ -z "$FSCK_OPTIONS" ] && _fsck_opts
462 fi
463
464 # make sure this script returns success
465 /bin/true